package com.jojubanking.boot.module.system.dal.mysql.usersxq;

import java.util.*;

import com.jojubanking.boot.framework.common.pojo.PageResult;
import com.jojubanking.boot.framework.mybatis.core.query.LambdaQueryWrapperX;
import com.jojubanking.boot.framework.mybatis.core.mapper.BaseMapperX;
import com.jojubanking.boot.module.system.dal.dataobject.usersxq.UsersXqDO;
import org.apache.ibatis.annotations.Mapper;
import com.jojubanking.boot.module.system.controller.admin.usersxq.vo.*;

/**
 * 用户信息 Mapper
 *
 * @author admin
 */
@Mapper
public interface UsersXqMapper extends BaseMapperX<UsersXqDO> {

    default PageResult<UsersXqDO> selectPage(UsersXqPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<UsersXqDO>()
                .likeIfPresent(UsersXqDO::getUsername, reqVO.getUsername())
                .eqIfPresent(UsersXqDO::getPassword, reqVO.getPassword())
                .likeIfPresent(UsersXqDO::getNickname, reqVO.getNickname())
                .eqIfPresent(UsersXqDO::getRemark, reqVO.getRemark())
                .eqIfPresent(UsersXqDO::getDeptId, reqVO.getDeptId())
                .eqIfPresent(UsersXqDO::getPostIds, reqVO.getPostIds())
                .eqIfPresent(UsersXqDO::getEmail, reqVO.getEmail())
                .eqIfPresent(UsersXqDO::getMobile, reqVO.getMobile())
                .eqIfPresent(UsersXqDO::getSex, reqVO.getSex())
                .eqIfPresent(UsersXqDO::getAvatar, reqVO.getAvatar())
                .eqIfPresent(UsersXqDO::getStatus, reqVO.getStatus())
                .eqIfPresent(UsersXqDO::getLoginIp, reqVO.getLoginIp())
                .betweenIfPresent(UsersXqDO::getLoginDate, reqVO.getLoginDate())
                .betweenIfPresent(UsersXqDO::getCreateTime, reqVO.getCreateTime())
                .orderByDesc(UsersXqDO::getId));
    }

    default List<UsersXqDO> selectList(UsersXqExportReqVO reqVO) {
        return selectList(new LambdaQueryWrapperX<UsersXqDO>()
                .likeIfPresent(UsersXqDO::getUsername, reqVO.getUsername())
                .eqIfPresent(UsersXqDO::getPassword, reqVO.getPassword())
                .likeIfPresent(UsersXqDO::getNickname, reqVO.getNickname())
                .eqIfPresent(UsersXqDO::getRemark, reqVO.getRemark())
                .eqIfPresent(UsersXqDO::getDeptId, reqVO.getDeptId())
                .eqIfPresent(UsersXqDO::getPostIds, reqVO.getPostIds())
                .eqIfPresent(UsersXqDO::getEmail, reqVO.getEmail())
                .eqIfPresent(UsersXqDO::getMobile, reqVO.getMobile())
                .eqIfPresent(UsersXqDO::getSex, reqVO.getSex())
                .eqIfPresent(UsersXqDO::getAvatar, reqVO.getAvatar())
                .eqIfPresent(UsersXqDO::getStatus, reqVO.getStatus())
                .eqIfPresent(UsersXqDO::getLoginIp, reqVO.getLoginIp())
                .betweenIfPresent(UsersXqDO::getLoginDate, reqVO.getLoginDate())
                .betweenIfPresent(UsersXqDO::getCreateTime, reqVO.getCreateTime())
                .orderByDesc(UsersXqDO::getId));
    }

}
